<!DOCTYPE html>
<html>

<head>
    <title>Innovation Plus Server - Upload</title>
    <link rel="stylesheet" href="static/styles/style.css">
    <style>
        body {
            display: flex;
            align-items: center;
            justify-content: center;
            min-height: 100vh;
            background: #8F9092;
        }

        .drag-area {
            border: 2px dashed #fff;
            height: 500px;
            width: 700px;
            border-radius: 5px;
            display: flex;
            align-items: center;
            justify-content: center;
            flex-direction: column;
        }

        .drag-area.active {
            border: 2px solid #fff;
        }

        .drag-area .icon {
            font-size: 100px;
            color: #fff;
        }

        .drag-area header {
            font-size: 30px;
            font-weight: 500;
            color: #fff;
        }

        .drag-area span {
            font-size: 25px;
            font-weight: 500;
            color: #fff;
            margin: 10px 0 15px 0;
        }

        .drag-area button {
            padding: 10px 25px;
            font-size: 20px;
            font-weight: 500;
            border: none;
            outline: none;
            background: #fff;
            color: #8F9092;
            border-radius: 5px;
            cursor: pointer;
        }

        .drag-area img {
            height: 100%;
            width: 100%;
            object-fit: cover;
            border-radius: 5px;
        }
    </style>
    <script src="https://unpkg.com/wavesurfer.js" crossorigin="anonymous"></script>
    <script type="module">
        import { importAudiofile, saveFile } from "./static/JS/dropdown.js"
        import { wavesurfer, setWavesurfer } from "./static/JS/script.js"

        let file;
        document.addEventListener('DOMContentLoaded', function () {
            const dropArea = document.querySelector(".drag-area"),
                dragText = dropArea.querySelector("header"),
                button = dropArea.querySelector("button"),
                input = dropArea.querySelector("input");

            button.onclick = () => {
                input.click();
            }

            input.addEventListener("change", function () {
                if (this.files.length) {
                    file = this.files[0];
                    dropArea.classList.add("active");
                    uploadFile();
                }
            });

            dropArea.addEventListener("dragover", (event) => {
                event.preventDefault();
                dropArea.classList.add("active");
                dragText.textContent = "Release to Upload File";
            });

            dropArea.addEventListener("dragleave", () => {
                dropArea.classList.remove("active");
                dragText.textContent = "Drag & Drop to Upload File";
            });

            dropArea.addEventListener("drop", (event) => {
                event.preventDefault();
                file = event.dataTransfer.files[0];
                uploadFile();
            });

            async function uploadFile() {
                let fileType = file.type;
                let validExtensions = ["audio/mpeg", "audio/wav", "audio/ogg"];
                if (validExtensions.includes(fileType)) {
                    await importAudiofile(file).then(async (e) => {
                        await saveFile();
                        dropArea.classList.remove("active");
                        dragText.textContent = "Drag & Drop to Upload File";
                        input.value = null;
                    });
                } else {
                    alert("This is not an valid Audio File!");
                    dropArea.classList.remove("active");
                    dragText.textContent = "Drag & Drop to Upload File";
                    input.value = null;
                }
                setWavesurfer(null)
            }
        });
    </script>
</head>

<body>
</body>
<div class="drag-area">
    <div class="icon"><i class="fas fa-cloud-upload-alt"></i></div>
    <header>Drag & Drop to Upload File</header>
    <span>OR</span>
    <button>Browse File</button>
    <input type="file" hidden>
</div>
<div id="waveform"></div>
<div class="progress progress-striped active" id="progress-bar">
    <div class="progress-bar progress-bar-info"></div>
</div>

</html>